<?php

$paypal = array();
$paypal['paypal_name'] = array('name' => __('PayPal username', 'easy-paypal'),
    'help' => __('Enter your name (or your company name). This is used for display purposes.', 'easy-paypal'),
    'validator' => 'notNull',
    'value' => 'EZ PayPal',
    'unique' => true);
$paypal['paypal_email'] = array('name' => __('PayPal email ID', 'easy-paypal'),
    'help' => __('Enter your PayPal email ID, which will receive your payments.', 'easy-paypal'),
    'value' => '',
    'validator' => 'email');
$paypal['sandbox_email'] = array('name' => 'PayPal SandBox email ID',
    'value' => '',
    'help' => 'PayPal SandBox email ID, which you can use for testing your setup. This entry is optional.');
$paypal['sandbox_mode'] = array('name' => 'Use SandBox [test] mode?',
    'type' => 'checkbox',
    'value' => false,
    'help' => 'If checked, PayPal SandBox will be used.');


$options = array();
$options['salt'] = array('name' => __('DB Security Salt', 'easy-paypal'),
    'type' => 'hidden',
    'help' => __('Not visible to the end user', 'easy-paypal'));
$options['support_email'] = array('name' => __('Support email ID', 'easy-paypal'),
    'help' => __('An email ID where your buyers can contact you for support.', 'easy-paypal'),
    'value' => '',
    'validator' => 'email');
$options['support_name'] = array('name' => __('Support Name', 'easy-paypal'),
    'value' => '',
    'help' => __('A friendly name to go with your support email ID.', 'easy-paypal'));
$options['expire_hours'] = array('name' => __('Expire Time (in hours)', 'easy-paypal'),
    'value' => 72,
    'validator' => 'number',
    'help' => __('The number of hours after which the download links will expire. When a purchase is made, an auto-generated email is sent to the buyer with a download link. The link expires after the number of hours you specify here. (Default is 72 hours).', 'easy-paypal'));
$options['random_storage'] = array('name' => __('Use Random Storage Location?', 'easy-paypal'),
    'help' => __('Randomize the storage location of your digital goods so that potential hackers cannot easily guess it? Recommended. Note that you will have to set the permission to the storage directory so that files can be uploaded there. Click on the <b>Show</b> button to see the random location.', 'easy-paypal'),
    'type' => 'checkbox',
    'value' => true,
    'button' => 'Show Location',
    'reveal' => 'storage_location');
if (method_exists('Installer', 'randString')) {
  $storage = Installer::randString();
}
else if (method_exists('EZ', 'randString')) {
  $storage = EZ::randString();
}
$options['storage_location'] = array('name' => __('Randomized Storage Location', 'easy-paypal'),
    'type' => 'hidden',
    'value' => $storage,
    'help' => __('Not visible to the end user', 'easy-paypal'));
$options['random_file'] = array('name' => __('Use Random File Name?', 'easy-paypal'),
    'help' => __('Randomize the file name of your digital goods on the server as you upload it so that potential hackers cannot easily guess it? Recommended.', 'easy-paypal'),
    'type' => 'checkbox',
    'value' => true);
$options['show_product_info'] = array('name' => __('Show Product Info?', 'easy-paypal'),
    'help' => __('If you would like to show product image and description on the page that comes up when your buyer clicks on the <strong>Buy Now</strong> buttons, check this option.', 'easy-paypal'),
    'value' => 0,
    'type' => 'checkbox');
$options['sales_ipn'] = array('name' => __('Enable Manual Posting of IPN Messages', 'easy-paypal'),
    'help' => __('If some of your IPN messages are not processed properly, you can try recovering from it using this tool. This tool will repost IPN messages as though they are coming from PayPal. Although accessible only when logged, it may still be a security hole. Leave it disabled if you are concerned about it.', 'easy-paypal'),
    'type' => 'checkbox',
    'value' => false);

$options['enable_server'] = array('name' => __('Enable Server Component', 'easy-paypal'),
    'help' => __('EZ PayPal comes with a server component that can facilitate interaction between other web applictaions. For instance, if you have sold a text link on your site as a subscription (using Easy Text Links), it can verify whether the subscription is still active by querying the server component. Leave it disabled if you do not need it.', 'easy-paypal'),
    'type' => 'checkbox',
    'value' => false);
$options['table_display'] = array('name' => __('Table Display Options', 'easy-paypal'),
    'help' => __('When the shop is displayed as an interactive searchable/sortable table, the page has to load fully before the interactive features turn on, which may look unseemly if you have a large number of products. You can hide the products table during loading, or turn off the interactive features, or show while loading (default, appropriate if you do not have a large number of products).', 'easy-paypal'),
    'value' => 'Default: Show while Loading',
    'type' => 'select',
    'options' => array('Turn off Interactive Features', 'Hide Table while Loading', 'Default: Show while Loading'),
    'reveal' => 'popup');
$options['table_pagination'] = array('name' => __('Table Pagination Options', 'easy-paypal'),
    'help' => __('EZ PayPal displays your e-shop using an paginated, interacitve table with 10 products per page by default. Your buyers can change this number interactively. And you can change the default here.', 'easy-paypal'),
    'value' => '10',
    'validator' => 'number');
$options['dynamic_menu'] = array('name' => __('Enable Dynamic Menu?', 'easy-paypal'),
    'type' => 'checkbox',
    'help' => __('By default, the menu on the admin pages expands on hover, which you may find annoying in the standalone mode. You can disable the feature here.', 'easy-paypal'),
    'value' => true,
    'reload' => true);

// I18n of frontend
$i18n = array();
$strings = array("Welcome to EZ PayPal Shop", "Product", "Id", "Category", "Price", "Buy?", "Buy Now", "Download it", "Contact us", "Sorry, no sales found.", "Sorry, your purchase has expired.", "Please edit the quantity and hit Buy Now", "Thank you for your purchase!");
foreach ($strings as $s) {
  $i18n[$s] = array('name' => $s, 'help' => "Enter your translation or customization for the string <strong>$s</strong>", 'value' => $s);
}
$i18n['show_google_translate'] = array('name' => __('Enable Google Translation of Admin Pages?', 'easy-paypal'),
    'help' => __('This plugin can display its admin pages using Google Translate. If you would like to see the pages in your language, please enable this option. You will then see a language selector near the top right corner where you can choose your language.', 'easy-paypal'),
    'type' => 'checkbox',
    'reload' => true,
    'value' => false);
